Index: /trunk/paper/notes.tex
===================================================================
--- /trunk/paper/notes.tex	(revision 92)
+++ /trunk/paper/notes.tex	(revision 93)
@@ -1,3 +1,3 @@
-\documentclass[a4paper,11pt,oneside]{article}
+\documentclass[a4paper,11pt,oneside,twocolumn]{article}
 \usepackage[english]{babel}
 \usepackage[ansinew]{inputenc}
@@ -16,8 +16,10 @@
 \usepackage{fancyhdr}
 \usepackage{verbatim}
-\addtolength{\textwidth}{4cm} \addtolength{\hoffset}{-2cm}
+\addtolength{\textwidth}{2cm} \addtolength{\hoffset}{-1cm}
 \begin{document}
 
 \section*{Abstract}
+
+The \textsc{Delphes} software provides a framework for fast simulation of particle interactions in a generic high-energy physics collider detector containing a tracking system, electromagnetic and hadronic calorimeters, and a muon system. It is an object-oriented system writen using the C++ programming language. Using input files originating from a Monte-Carlo event generator such as \textsc{pythia} and \textsc{herwig}, \textsc{Delphes} creates ``high-level" analysis objects.\\ 
 
 \section{Introduction}
@@ -26,156 +28,160 @@
 % - 2) relativement bonne prÃ©diction en premiÃšre approximation
 % - 3) permet de comparer
-Full simulation of the response of large detectors components to high energy particles requires a lot of computing resources. Moreover, a good knowledge of the exact geometry of subdetectors and dead material content is mandatory. 
-
-Fast simulation can be a  powerful predictive tool for typical response of a large detector in high energy collider.
-
-The fast simulation of the detector response takes into account geometrical
-acceptance of sub-detectors and their finite energy resolution, no smearing is
-applied on particle direction. Charged particles, once are in the fiducial
-volume of the detector are assumed to be reconstructed with $100\%$ probability.
-The energy of each particle produced after hadronization, with a lifetime
-$c\tau$ bigger than $10~\textrm{mm}$ is then smeared according to detectors along
-particule's direction. For particles with a short lifetime such as the $K_s$,
-the fraction of electromagnetic or hadronic energy is determined according to
-its decay products. The calorimeter is assumed to cover the pseudorapidity range
-$|\eta|<3$ and consists in an electromagnetic and an hadronic part. The energy
-resolution is given by $\sigma_{E}/E=0.05/\sqrt{E} \oplus 0.25/E \oplus 0.0055$
-for the electromagnetic part and by $\sigma_{E}/E=0.91/\sqrt{E}\oplus 0.038$ for
-the hadronic part, where the energy is given in GeV. A very forward calorimeter
-is assumed to cover $3<|\eta|<5$ with an electromagnetic and hadronic energy
-resolution function given by $\sigma_{E}/E=1.5/\sqrt{E}\oplus 0.06$ and
-$\sigma_{E}/E=2.7/\sqrt{E}\oplus 0.13$ respectively.\\
+
+A fast simulation of a typical \textsc{lhc} multipurpose detector response can be used to obtain more realistic observables and fast approximate estimates of signal and background rates for specific channels. \textsc{Delphes} includes the most crucial detector apects as jet reconstruction, momentum/energy smearing for leptons, photons and hadrons and missing transverse energy. Starting from ``particle-level" information, the package provides reconstructed jets, isolated leptons, photons, reconstructed charged tracks, calorimeter towers and the expected transverse missing energy. Although this kind of approach yields much realistic results than a simple ``parton-level" analysis, a quick simulation comes at the expense of detector details. Therefore, the interactions not simulated in \textsc{Delphes} are: secondary interactions, multiple interactions, photon conversion, electron Bremsstrahlung, magnetic field effects, detector dead materials.\\
+
+The simulation package proceeds in two stages. The first part is executed on the generated events. ``Particle-level" informations are read from input files and stored in a {\it \textsc{gen}} \textsc{root} tree. Three varieties of input files can currently be used as input in \textsc{Delphes}. In order to process events from many different generators, the standard Monte Carlo event structure StdHep can be used as an input. Besides, \textsc{delphes} can also provide detector response for events read in "Les Houches Event Format" (\textsc{lhef}) and \textsc{root} files obtained using the {\bf h2root} converter program. This first stage is performed using three C++ classes: {\verb HEPEVTConverter }, {\verb LHEFConverter } and {\verb STDHEPConverter }. Afterwards, \textsc{delphes} performs a simple trigger simulation and reconstruct "high-level objects". These informations are organised in classes and each objects are ordered with respect to the transverse momentum. The output of the various C++ classes is stored in the {\it Analysis} tree. The program is driven by a datacard (data/DataCardDet.dat) which allow a large spectrum of running conditions by modifying basic detector parameters, including calorimeter and tracking coverage and resolution, thresholds or jet algorithm parameters.\\
+
+\section{Central detector simulation}
 
 \begin{figure}[!h]
 \begin{center}
-\includegraphics[width=0.7\textwidth]{detectorAng.eps}
+\includegraphics[width=\columnwidth]{detectorAng.eps}
+\caption{\small{detectorAng.eps}}
+\label{fig:genDet}
+\end{center}
+\end{figure}
+
+The overall layout of the general purpose detector simulated by \textsc{Delphes} is shown in figure \ref{fig:GenDet}. A central tracking system surrounded by an electromagnetic (\textsc{ecal}) and a hadron calorimeter (\textsc{hcal}). A forward calorimeter ensure a larger geometric coverage for the measurement of the missing transverse energy. The fast simulation of the detector response takes into account geometrical acceptance of sub-detectors and their finite energy resolution. No smearing is applied on particle direction.\\
+
+Before starting to loop over events, the {\verb RESOLution } class loads all sub-detector resolutions and coverage from the detector parameter file. If no such file is provided, predifined values are used. The coverage of the various sub-systems used in the default configuration are summarized in table \ref{tab:defEta}.
+
+\begin{table}[!h]
+\begin{center}
+\begin{tabular}[!h]{lll}
+\hline
+Sub-system   & Card flag & $|\eta|^{max}$\\\hline
+Tracking     & {\verb MAX_TRACKER } & 2.5\\
+Calorimeters & {\verb MAX_CALO_CEN } & 3.0\\
+             & {\verb MAX_CALO_FWD } & 5.0\\
+Muon         & {\verb MAX_MU } & 2.4\\\hline
+\end{tabular}
+\label{tab:defEta}
+\end{center}
+\end{table}
+
+\subsection{Simulation of calorimeters response}
+
+The energy of all particle considered as stable in the generator particle list are smeared according to a resolution depending which sub-calorimeter is assumed to be used for the energy measurement. For particles with a short lifetime such as the $K_s$, the fraction of electromagnetic or hadronic energy is determined according to its decay products. The response of the each sub-calorimeter is parametrized as a function of the energy
+\begin{equation} 
+\frac{\sigma}{E} = \frac{S}{\sqrt{E}} \oplus \frac{N}{E} \oplus C,
+\end{equation}
+where S is the stochastic term, N the noise and C the constant term.\\
+
+The response of the detector is applied to the electromagnetic and the hadronic particles through the {\verb SmearElectron }and {\verb SmearHadron } functions. The 4-momentum $p^\mu$ are smeared with a parametrisation directly derived from the detector techinal designs. In the default parametrisation, the calorimeter is assumed to cover the pseudorapidity range $|\eta|<3$ and consists in an electromagnetic and an hadronic part. Coverage between pseudorapidities of 3.0 and 5.0 is provided by a forward calorimeter. The response of this calorimeter can be different for electrons and hadrons. The default values of the stochastic, noisy and constant terms as well as the ``Card flag" names used in the configuration file are given in table \ref{tab:defResol}.\\
+
+\begin{table}[!h]
+\begin{center}
+\begin{tabular}[!h]{lclc}
+\hline
+\multicolumn{2}{c}{Resolution Term}   & Card flag & Value\\\hline
+Central \textsc{ecal} & S & {\verb ELG_Scen }  & 0.05 \\
+             & N & {\verb ELG_Ncen }  & 0.25 \\
+             & C & {\verb ELG_Ccen }  & 0.0055 \\
+Forward \textsc{ecal} & S & {\verb ELG_Sfwd }  & 2.084 \\
+             & N & {\verb ELG_Nfwd }  & 0.0 \\
+             & C & {\verb ELG_Cfwd }  & 0.107 \\
+Central \textsc{hcal} & S & {\verb HAD_Shcal } & 1.5 \\
+             & N & {\verb HAD_Nhcal } & 0.\\
+             & C & {\verb HAD_Chcal } & 0.05\\
+Forward \textsc{hcal} & S & {\verb HAD_Shf }   & 2.7\\
+             & N & {\verb HAD_Nhf }   & 0. \\
+             & C & {\verb HAD_Chf }   & 0.13\\
+\hline
+\end{tabular}
+\label{tab:defResol}
+\end{center}
+\end{table}
+
+The energy of electron and photon particles found in the particle list are smeared using the \textsc{ecal} resolution terms. Charged and neutral final state hadrons interact with the \textsc{ecal}, \textsc{hcal} and the forward calorimeter. Some long-living particles, such as the $K_s$, possessing lifetime $c\tau$ smaller than 10~mma are considering as stable particles although they decay in the calorimeters. The energy smearing of such particles is performed using the expected fraction of the energy, determined according to their decay products, that whould be deposited into the \textsc{ecal} ($E_{ecal}$) and into the \textsc{hcal} ($E_{hcal}$). Defining $F$ as the fraction of the energy leading to a \textsc{hcal} deposit, the two energy values are given by 
+\begin{equation}
+E_{hcal} = E \times F ~\mathrm{and}~ E_{ecal} = E \times (1-F),
+\end{equation}
+where $0 \leq F \leq 1$. The electromagnetic part is handled as the electrons, while the resolution terms used for the hadronic part are {\verb HAD_Shcal }, {\verb HAD_Nhcal } and {\verb HAD_Chcal }. The resulting final energy given after the application of the smearing is then $E = E_{hcal} + E_{ecal}$.\\
+
+
+\subsection{Muon smearing}
+
+Muons candidates are searched
+The smearing ot the muon 4-momentum $p^\mu$ is given by a Gaussian smearing of the $p_T$ function \texttt{SmearMuon}. Only the $p_T$ is smeared, but neither $\eta$ nor $\phi$. 
+
+\subsection{Tracks reconstruction}
+
+All stable charged particles lying inside the fiducial volume of the tracking coverage provide a track. The reconstructio efficiency is manageable in the input datacard through the {\verb TRACKING_EFF } term. By default, a track is assumed to be reconstructed with $90\%$ probability.
+
+\subsection{Calorimetric towers}
+
+All undecayed particles, except muons and neutrinos are producing a calorimetric tower.  The same particles enter in the calculation of the missing transverse energy. \textit{what is used is the particle smeared momentum, not the calorimetric towers!}
+
+\subsection{Isolated lepton reconstruction}
+
+Photon and electron candidates are reconstructed if they fall into the acceptance of the tracking system and have a transverse momentum above the {\verb ELEC_pt } value (10~GeV by default). Muons candidates are searched 
+
+Lepton isolation demands that there is no other charged particles with $p_T>2$~GeV within a cone of $\Delta R<0.5$ around the lepton.\\ 
+
+\section{``High-level" objects reconstruction}
+
+\subsection{Jet reconstruction}
+
+Jets are reconstructed using a cone algorithm with $R=0.7$ and make only use of the smeared particle momenta. The reconstructed jets are required to have a transverse momentum above 20~GeV and $|\eta|<3.0$. A jet is tagged as $b$-jets if its direction lies in the acceptance of the tracker, $|\eta|<0.5$, and if it is associated to a parent $b$-quark. A $b$-tagging efficiency of $40\%$ is assumed if the jet has a parent $b$ quark. For $c$-jets and light/gluon jets, a fake b-tagging efficiency of $10 \%$ and $1 \%$ respectively is assumed.\\
+
+\subsection{{\it b}tagging}
+
+The simulation of the b-tagging is based on the detector efficiencies assumed (1) for the tagging of a b-jet and (2) for the mis-identification of other jets as b-jets. This relies on the TAGGING\_B, MISTAGGING\_C and MISTAGGING\_L constants, for (respectively) the efficiency of tagging of a b-jet, the efficiency of mistagging a c-jet as a b-jet, and the efficiency of mistatting a light jet (u,d,s,g) as a b-jet. The (mis)tagging relies on the particle ID of the most energetic particle within a cone around the observed (eta,phi) region, with a radius CONERADIUS.
+
+\subsection{Tau identification}
+
+\begin{wrapfigure}{l}{0.5\columnwidth}
+\includegraphics[width=0.5\columnwidth]{Tau.eps}
 \caption{\small{detectorAng.eps}}
 \label{h_WW_ss_cut1}
+\end{wrapfigure}
+
+Jets originating from $\tau$-decay are identified using an identification procedure consistent with the one applied in a full detector simulation. The tagging rely on two tau properties. First, in roughly 75$\%$ of the time, the hadronic $\tau$-decay products contain only one charged hadron and a number of $\pi^0$. Second, the particles arisen from the $\tau$-lepton produce narrow jets in the calorimeter. 
+
+\subsubsection*{Electromagnetic collimation}
+
+To use the narrowness of the $\tau$-jet, the \textit{electromagnetic collimation} ($C_{\tau}^{em}$) is defined as the sum of the energy in a cone with $\Delta R = ${\verb TAU_CONE_ENERGIE } around the jet axis divided by the energy of the reconstructed jet. The energy in the small cone is calculated using the towers objects. To be taken into account a calorimeter tower should have a transverse energy above a given threshold {\verb M_SEEDTHRESHOLD}. A large fraction of the jet energy, denominated here with {\verb TAU_EM_COLLIMATION } is expected in this small cone. The quantity is represented in figure \ref{fig:tau1} for the default values (see table \ref{tab:tauRef})
+
+\begin{figure}[!h]
+\begin{center}
+\includegraphics[width=0.8\columnwidth]{figures/Taujets1.eps}
+\caption{\small{}}
+\label{fig:tau1}
 \end{center}
 \end{figure}
 
-
-The acceptance cuts applied on leptons and jets used in this section are the
-following :\\
-
-\begin{itemize}
-
-\item Electrons and muons are reconstructed if they fall into the acceptance of
-the tracker, assumed to be $|\eta|<2.5$, and have to have a transverse momentum
-above 10~GeV (the energy resolution of muons is taken to be the same as for
-electrons). Lepton isolation demands that there is no other charged particles
-with $p_T>2$~GeV within a cone of $\Delta R<0.5$ around the lepton.\\
-
-\item Jets are reconstructed using a cone algorithm with $R=0.7$ and make only
-use of the smeared particle momenta. The reconstructed jets are required to have
-a transverse momentum above 20~GeV and $|\eta|<3.0$. A jet is tagged as $b$-jets
-if its direction lies in the acceptance of the tracker, $|\eta|<0.5$, and if it
-is associated to a parent $b$-quark. A $b$-tagging efficiency of $40\%$ is
-assumed if the jet has a parent $b$ quark. For $c$-jets and light/gluon jets, a
-fake
-b-tagging efficiency of $10 \%$ and $1 \%$ respectively is assumed.\\
-
-\item A jet is tagged as a $\tau$-jet if more than $90\%$ of its energy is
-localized in a cone of $\Delta R=0.15$ around its axis. Moreover, this jet must
-have its direction in the acceptance of the tracker and have exactly one charged
-particle with $p_{T}>2$~GeV within a cone $\Delta R<0.4$ around the jet axis.
-This procedure selects taus decaying hadronically with a typical efficiency of
-$60\%$. Moreover, the minimal $p_T$ of the $\tau$-jet is required to be
-10~GeV.\\
-
-\end{itemize}
-
-\section{implementation}
-\subsection{Electron smearing}
-The smearing of the electron 4-momentum $p^\mu$ is
- - if the electron is in the tracker ($\eta < MAX\_TRACKER$)
-	Gaussian smearing with $\sigma = ELG_Ccen*E \oplus ELG_Ncen \oplus
-ELG_Scen*\sqrt{E}$
- - else Gaussian smearing with $\sigma = ELS_Cfwd*E \oplus ELG_Sfwd*\sqrt{E}$
-function \texttt{SmearElectron}
-Only the energy $E$ is smeared, but neither $\eta$ nor $\phi$.
-No negative values for the energy after smearing. If so, the $4$-momentum is set
-to $(0,0,0,0)$.
-\textbf{For the moment, electrons with $|\eta|> 5$ are also smeared !!!}
-
-\subsection{Muon smearing}
-The smearing ot the muon 4-momentum $p^\mu$ is given
-by a Gaussian smearing of the $p_T$
-function \texttt{SmearMuon}
-Only the $p_T$ is smeared, but neither $\eta$ nor $\phi$.
-No negative values for the energy after smearing. If so, the 4-momentum is set
-to $(0,0,0,0)$.
-
-\subsection{Hadron smearing}
-The energy of the hadron is smeared in the following ways:
- - if the hadron is in the central calorimeter (eta < MAX\_CALO\_CEN)
-	Gaussian smearing with $\sigma = HAD_Chcal*E_{hcal} \oplus HAD_Nhcal
-\oplus HAD_Shcal*\sqrt{E_{hcal}} 
-			               + HAD_Cecal*E_{ecal} \oplus HAD_Necal
-\oplus HAD_Secal*\sqrt{E_{ecal}}$ 
-	where $E_{hcal} + E_{ecal} = E$. As some long-living particles decay in
-the calorimeters,
-	some of them decay mostly in the ECAL, some mostly in the HCAL.
-$E_{hcal}$ and $E_{ecal}$ are 
-	given by $E_{hcal} = E \times F$ and $E_{ecal} = E times (1-F)$, where
-$F$ is a fraction 
-	$0 \leq F \leq 1$ describing each particles. By default, $F=1.$ but is
-$F=0.7$ for $K^0_S$ and $\Lambda$.
- - if the hadron is somewhere else (\textbf{even outside the forward
-calorimeters !!!})
-	Gaussian smearing with $\sigma = HAD_Chf*E \oplus HAD_Nhf \oplus
-HAD_Shf*\sqrt{E}$ 
-
-Ainsi, pour les particules considÃ©rÃ©es comme stables par PYTHIA
-mais non stables dans un dÃ©tecteur tel CMS ($c\tau < 4m$), les
-dÃ©pÃŽts laissÃ©s dans les diffÃ©rents dÃ©tecteurs sont directement
-liÃ©s aux modes de dÃ©sintÃ©grations de ces particules. Les
-hypothÃšses des dÃ©pÃŽts d'Ã©nergie sont donnÃ©es dans le tableau
-\ref{depot}.\newline
+\subsubsection*{$\tau$ selection using tracks}
+
+\begin{figure}[!h]
+\begin{center}
+\includegraphics[width=0.8\columnwidth]{figures/Taujets2.eps}
+\caption{\small{}}
+\label{h_WW_ss_cut1}
+\end{center}
+\end{figure}
+
+The tracking isolation for the $\tau$ identification requires that the number of tracks associated to a particle with $p_T >$ {\verb PT_TRACK_TAU } is one and only one in a cone with $\Delta R =$ {\verb TAU_CONE_TRACKS }. This cone should be entirely included in the tracker to be taken into account. This procedure selects taus decaying hadronically with a typical efficiency of $60\%$. Moreover, the minimal $p_T$ of the $\tau$-jet is required to be {\verb TAUJET_pt }(default value: 10~GeV).\\
 
 \begin{table}[!h]
 \begin{center}
-\begin{tabular}{|c|c|c|c|c|c|}
-\hline
-\emph{Particules stables} & \emph{Stable} &\emph{Mode de}
-&$\Gamma_{i}/\Gamma$&\emph{DÃ©pot}&\emph{DÃ©pot}\\
-\emph{dans PYTHIA}&\emph{dans
-CMS}&\emph{desintÃ©gration}&&\emph{ECAL}&\emph{HCAL}\\\hline\hline
-$\pi^{\pm}$ & oui & & & 0 & 1 \\ \hline $K^{\pm}$ & oui & & & 0 &
-1 \\\hline $K^{0}_{S}$ & non & $\gamma\gamma\gamma\gamma$ & 0.31 &
-0.3 & 0.7\\
-& & $\pi^{+}\pi^{-}$& 0.69 &&\\\hline $K^{0}_{L}$ & oui & & & 0 &
-1\\\hline $\Lambda^{0}$ & non & $\pi^{-}p/\pi^{+}\overline{p}$ &
-0.64&
-0.3 & 0.7\\
-& & $n\pi^{0}$ & 0.36 & & \\\hline $\gamma$& oui & & & 1
-&0\\\hline
+\begin{tabular}[!h]{llc}
+\hline
+Tau definition  & Card flag & Value\\\hline
+$\Delta R^{for~em}$     & {\verb TAU_CONE_ENERGIE } & 0.15\\
+min $E_{T}^{tower}$     & {\verb M_SEEDTHRESHOLD }  & 1.0~GeV\\
+$C_{\tau}^{em}$         & {\verb TAU_EM_COLLIMATION } & 0.95.\\
+$\Delta R^{for~tracks}$ & {\verb TAU_CONE_TRACKS } & 0.4\\
+min $p_T^{tracks}$      & {\verb PT_TRACK_TAU } & 2 GeV\\\hline
 \end{tabular}
-\caption{HypothÃšses des dÃ©pÃŽts d'Ã©nergie pour les particules les
-plus abondantes des jets.} \label{depot}
+\label{tab:tauRef}
 \end{center}
 \end{table}
 
-
-function \texttt{SmearHadron}
-There is no ecal-hcal separation in the forward calorimeter.
-No negative values for the energy after smearing. If so, the 4-momentum is set
-to $(0,0,0,0)$.
-
-\subsection{Calorimetric towers}
-All final particles, which are neither muons nor neutrinos are produce a
-calorimetric tower.
-The same particles enter in the calculation of the missing transverse energy.
-\textit{what is used is the particle smeared momentum, not the calorimetric
-towers!}
-
-\subsection{Tracks}
-All final charged particles
-
-\subsection{Time of flight}
-Some subdetectors have the ability to measure the time of flight of the particle.
-This correspond to the delay after which the particle is observed in the detector, after the bunch crossing.
-The time of flight measurement of ZDC and FP420 detector is implemented here.
-For the ZDC, the formula is simply
+\subsection{Transverse missing energy}
+
+\section{Very forward detectors simulation}
+
+Some subdetectors have the ability to measure the time of flight of the particle. This correspond to the delay after which the particle is observed in the detector, after the bunch crossing. The time of flight measurement of ZDC and FP420 detector is implemented here. For the ZDC, the formula is simply
 \begin{equation}
  t_2 = t_1 + \frac{1}{v} \times \big( \frac{s-z}{\cos \theta}\big),
@@ -188,70 +194,12 @@
 NB : for the moment, only neutrons and photons are assumed to be able to reach the ZDC. All other particles are neglected
 
-To fix the ideas, if the ZDC is located at $s=140~\textrm{m}$, neglecting $z$ and $\theta$, and assuming that $v=c$, one gets $t=0.47~\mu\textrm{s}$.
-
-\subsection{Tau identification}
-
-Two ways to identify a tau : using the energy inside a cone or the number of
-tracks in the cone.
-\begin{itemize}
-\item From the energy in the cone of radius TAU\_CONE\_ENERGY. To be taken into
-account, a calo tower should (1) have a transverse energy $E_T = \sqrt{E_X^2 +
-E_Y^2}$ above a given threshold M\_SEEDTHRESHOLD, (2) be inside a cone with a
-radius R and the axis defined by (eta,phi).
-\item From the number of tracks in the cone of radius TAU\_CONE\_TRACKS. To be
-taken into account, a track should (1) have a transverse momentum $ p_T =
-\sqrt{p_X^2 + p_Y^2} $ above a given threshold, (2) be inside a cone with a
-radius R and the axis defined by (eta,phi).
-\end{itemize}
-
-\begin{wrapfigure}{l}{0.3\textwidth}
-\includegraphics[width=0.3\textwidth]{Tau.eps}
-\caption{\small{detectorAng.eps}}
-\label{h_WW_ss_cut1}
-\end{wrapfigure}
-
-
-To identify a tau, one requires the \textit{electromagnetic collimation} and the
-\textit{tracking isolation}.
-The electromagnetic collimation is a kind of calorimetric isolation required
-around the jet axis.
-One requires that most of the energy of the cone is located in a small cone in
-the middle of the jet cone:
- \begin{equation}
-   %C_{\tau}^{e.m.} = \frac{ \Sum E_T^{cell}(\Delta R= TAU\_CONE\_ENERGY)}{ 
-\sum E_T^{cell} (\Delta R= CONE\_RADIUS) > TAU\_EM\_COLLIMATION
- \end{equation}
- Typical values are TAU\_CONE\_ENERGY=0.15 ,  CONE\_RADIUS=0.7 and
-TAU\_EM\_COLLIMATION = 0.95.
-No further calorimetric isolation is required.
-
-The tracking isolation for the tau identification requires that the number of
-tracks associated to a particle with $p_T > PT\_TRACK\_TAU$ is one and only one
-in a cone with $\Delta R = TAU\_CONE\_TRACKS$. This cone should be entirely
-included in the tracker to be taken into account. Typical calues are
-$TAU\_CONE\_TRACKS = 0.4$ and $PT\_TRACK\_TAU = 2 GeV$.
-
-This means that the list of tau jet candidates includes the electron candidates.
-
-
-
-\subsection{B-tagging}
-The simulation of the b-tagging is based on the detector efficiencies assumed
-(1) for the tagging of a b-jet and (2) for the mis-identification of other jets
-as b-jets. This relies on the TAGGING\_B, MISTAGGING\_C and MISTAGGING\_L
-constants, for (respectively) the efficiency of tagging of a b-jet, the
-efficiency of mistagging a c-jet as a b-jet, and the efficiency of mistatting a
-light jet (u,d,s,g) as a b-jet. The (mis)tagging relies on the particle ID of
-the most energetic particle within a cone around the observed (eta,phi) region,
-with a radius CONERADIUS.
-
-\section{Validation}	
+To fix the ideas, if the ZDC is located at $s=140~\textrm{m}$, neglecting $z$ and $\theta$, and assuming that $v=c$, one gets  $t=0.47~\mu\textrm{s}$.
+
+\section{Simulation physics validation}	
+
 \section{conclusion}
 
 \appendix
-Attention : in SmearUtil::NumTracks, the function arguments 'Eta' and 'Phi' have
-been switched. Previously, 'Phi' was before 'Eta', now 'Eta' comes in front.
-This is for consistency with the other functions in SmearUtil. Check your
-routines, when using NumTracks !
+Attention : in SmearUtil::NumTracks, the function arguments 'Eta' and 'Phi' have been switched. Previously, 'Phi' was before 'Eta', now 'Eta' comes in front. This is for consistency with the other functions in SmearUtil. Check your routines, when using NumTracks !
 
 In the list of input files, all files should have the same type 